/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/** This is the config menu. See
 * documentation for the class
 * 'Menu' for more information. */

#ifndef __CONFIGMENU__
#define __CONFIGMENU__

#include <string>
#include <vector>

#include "../Lobby.hpp"
#include "../../shared/definitions/Coordinates.hpp"
#include "../../shared/gui/Menu.hpp"
#include "../../shared/gui/BasicUserInterface.hpp"

class ConfigMenu : public Menu{
public:
    ConfigMenu(UIMenu*, Lobby*, BasicUserInterface*);
    ~ConfigMenu();
    void runItem(unsigned int, int);
private:
    Lobby* lobby;
    BasicUserInterface* bui;

    // variables for display settings
    bool fullscreen, oldfullscreen;
    Coordinates res, oldres;

    unsigned int resno;
    std::vector<Coordinates> resolutions;

    void resetApplyButton();

    std::string resolutionButtonText();
};

#endif /* __MAINMENU__ */
