/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2012  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "LocalGame.hpp"

INPUTTYPE LocalGame::startGameMenu(){
    sgm = new StartGameMenu(uim);
    sgm->refresh();

    // loop for selecting game options
    bool selectionloop = true;
    while (selectionloop){
        currinput = basicuserinterface->getInput(NOINPUT);
        switch (currinput){
        case QUIT:
            selectionloop = false;
            currinput = QUIT;
            break;
        case NOINPUT:
            sgm->print();
            break;
        case TIME:
            break;
        default:
            switch(sgm->getInput(currinput)){
            case QUIT:
                selectionloop = false;
                currinput = QUIT;
                break;
            case CONTINUEGAME:
                if (fshandler->exists("save/savegame01.map")) {
                    levelname = "save/savegame01.map";
                } else {
                    levelname = sgm->getSelectedMap();
                }
                selectionloop = false;
                currinput = START;
                break;
            case START:
                levelname = sgm->getSelectedMap();
                selectionloop = false;
                currinput = START;
                break;
            default:
                break;
            }
        }
    }
    delete sgm;
    return currinput;
}

void LocalGame::init(GraphicSet* gs, BasicUserInterface* bui, FSHandler* fsh) {
    graphicset = gs;
    basicuserinterface = bui;
    fshandler = fsh;

    uim = new UIMenu(basicuserinterface->getSize(),
                     Coordinates(0,0),gs,basicuserinterface);
}
