/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __RUNMODE_H__
#define __RUNMODE_H__



/** The mode which the program is
 * runing in is an int value. But
 * to clarify what is going on
 * please use this alias. */
typedef int RUNMODE;


/** The mode 'QUIT' does not need to
 * be implemented, it just exists to
 * signalize that the program will
 * quit. */
enum RunModes{
    EXIT, LOBBY, CLIENT, EDITOR, HOTSEAT
};


class RunMode{
public:
    /** A RunMode can do anything,
     * the only important thing is
     * that it returns the runmode
     * that will follow when run. */
    virtual RUNMODE run() = 0;
};


#endif /* __RUNMODE_H__ */
