/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <iostream>

#include "Coordinates.hpp"

int main(){
    Coordinates* field[7][7];

    std::cout << "Distance calculation tests:\n";

    for (int x=0; x<7;x++){
        for (int y=0; y<7;y++){
            field[y][x] = new Coordinates(x,y);
        }
    }
    for (int x=0; x<7;x++){
        if(x%2 == 1) std::cout << "  ";
        for (int y=0; y<7;y++){
            std::cout << (field[y][x])->distanceTo(*(field[4][2])) << "   ";
        }
        std::cout << "\t";
        if(x%2 == 1) std::cout << "  ";
        for (int y=0; y<7;y++){
            std::cout << (field[y][x])->distanceTo(*(field[2][3])) << "   ";
        }
        std::cout << std::endl;
    }
    std::cout << std::endl;
    for (int x=0; x<7;x++){
        if(x%2 == 1) std::cout << "  ";
        for (int y=0; y<7;y++){
            std::cout << (field[y][x])->distanceTo(*(field[3][2])) << "   ";
        }
        std::cout << "\t";
        if(x%2 == 1) std::cout << "  ";
        for (int y=0; y<7;y++){
            std::cout << (field[y][x])->distanceTo(*(field[3][3])) << "   ";
        }
        std::cout << std::endl;
    }
    std::cout << std::endl;

    for (int i=0; i<7; i++) {
        for (int j=0; j<7; j++) {
            delete field[i][j];
        }
    }

    std::cout << "Mathematic operations tests:\n";

    Coordinates *a, *b, *c;
    Coordinates x, y, z;

    a = new Coordinates(1,2);
    b = new Coordinates(*a);
    c = new Coordinates(3,4);

    x = Coordinates(5,6);
    y = *a + *b;
    z = x*4;

    std::cout << "(" << a->x << "," << a->y << ")"
                 "(" << b->x << "," << b->y << ")"
                 "(" << c->x << "," << c->y << ")"
                 "(" << x.x  << "," << x.y  << ")"
                 "(" << y.x  << "," << y.y  << ")"
                 "(" << z.x  << "," << z.y  << ")"
                     << std::endl;

    delete a;
    delete b;
    delete c;
}

