/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2012  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "PathNode.hpp"

#ifdef DEBUG
unsigned int PathNode::instances = 0;
#endif

PathNode::PathNode() {
    l = NULL;
#ifdef DEBUG
    PathNode::instances++;
#endif
}

PathNode::PathNode( Coordinates pos, PathNode* last, Coordinates to ) {
    f = pos;
    l = last;
    if (l != NULL) {
        kc = last->kc +1;
    } else {
        kc = 0;
    }
    ec = kc + f.distanceTo(to);
#ifdef DEBUG
    PathNode::instances++;
#endif
}

PathNode::PathNode(const PathNode & orig) {
    f = orig.f;
    l = orig.l;
    kc = orig.kc;
    ec = orig.ec;
#ifdef DEBUG
    PathNode::instances++;
#endif
}


#ifdef DEBUG
PathNode::~PathNode() {
    PathNode::instances--;
}
#endif

void PathNode::setLast(PathNode* last) {
    ec -= kc - last->kc +1;
    kc = last->kc +1;
    l = last;
}
