/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* PathName provides an abstraction layer for the usage
 * of different librarys to eccess files. */

#ifndef PATHNAME_SWITCH
#define PATHNAME_SWITCH

#ifndef ALLEGRO5
class BstPathName;
typedef BstPathName PathName;
#include "boost/BstPathName.hpp"
#else
class Al5PathName;
typedef Al5PathName PathName;
#include "allegro5/Al5PathName.hpp"
#endif

#endif // PATHNAME_SWITCH

#ifndef PATHNAME_HPP
#define PATHNAME_HPP

#include <string>

class VirtualPathName {
public:
    virtual std::string string() =0;
    virtual const char* c_str() =0;

    virtual bool exists() =0;

    virtual bool operator==(PathName dir);

protected:
    virtual void append(std::string) =0;
    virtual void append(const char*) =0;

    virtual void setPathName(std::string) =0;
    virtual void setPathName(const char*) =0;
};

#endif // PATHNAME_HPP
