/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef AL5_PATHNAME_HPP
#define AL5_PATHNAME_HPP

#include <string>
#include <allegro5/allegro.h>

#include "../PathName.hpp"



class Al5PathName : public VirtualPathName {
public:
    Al5PathName();
    Al5PathName(const char*);
    Al5PathName(std::string);
    Al5PathName(const Al5PathName&);
    ~Al5PathName();

    std::string string();
    const char* c_str();
    ALLEGRO_PATH* al5Path();

    virtual bool exists();

    Al5PathName operator=(const char*);
    Al5PathName operator=(std::string);
    Al5PathName operator=(Al5PathName);

    Al5PathName operator/=(const char*);
    Al5PathName operator/=(std::string);
    Al5PathName operator/=(Al5PathName);


    Al5PathName operator/(const char*);

protected:
    void append(std::string);
    void append(const char*);

    void setPathName(std::string);
    void setPathName(const char*);
    void setPathName(Al5PathName);

private:
    ALLEGRO_PATH* pathname;
};

#endif // AL5_PATHNAME_HPP
