/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2012  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef VIRTUALUIMENU_HPP
#define VIRTUALUIMENU_HPP

#include <string>

#include "../../definitions/Coordinates.hpp"
#include "../MenuItem.hpp"

class VirtualUIMenu {
public:
    virtual void drawBox() =0;

    /**
     * draws the given text at the given position
     */
    virtual void drawText(std::string, MENUITEMMODE, unsigned int) =0;

    /**
     * draws the given text at the given position
     */
    virtual void drawTextLeft(std::string, MENUITEMMODE, Coordinates) =0;

    /**
     * draws the given text at the given position
     */
    virtual void drawTextCenter(std::string, MENUITEMMODE, Coordinates) =0;

    /**
     * draws the given text at the given position
     */
    virtual void drawTextRight(std::string, MENUITEMMODE, Coordinates) =0;
};

#endif // VIRTUALUIMENU_HPP
