/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _TERRAFORMER_H
#define	_TERRAFORMER_H

#include "Unit.hpp"

class TerraFormer : public Unit{
public:
    TerraFormer(Coordinates opos, PLAYER player);

    /** move() for TerraFormer does
     *  terraforming when unit lands
     *  on a field containing water
     */
    void move(unsigned int time);

    /** terraForm() increases the hight
     *  of a map tile by one if it
     *  contains water and decreases it
     *  otherwise
     */
    void terraForm();
};

#endif	/* _TERRAFORMER_H */

